#include "command.h" 
#include "uart.h"
#include "reset.h"
#include "nRF24L01P.h"
#include "bcc.h"
#include "pwm.h"
#include "chipID.h"
#include "eeprom.h"
#include <string.h>
//#include <stdio.h>



/****************************
ϵͳʼ

0:ɹ
1:EEPROMȡʧܣϵͳĬ
2:EEPROMȡϵͳ
3:2401ʼʧ
*****************************/
uint8_t InitSystem()
{
    nRF_ConfigStruct conf;
    uint8_t ret;
    EA = 1;

    ret = EEPROM_ReadConfig((uint8_t *)&conf); 
    if(ret)
    {
        //Ч
        if(ret == 1)
        {
            //ȻָĬ
            RSTConf();
            ret = EEPROM_ReadConfig((uint8_t *)&conf);
            if(ret)
            {
                LED = 0;
                while(1);
            }
        }else
        {
            LED = 0;
            while(1);
        }
    }
    //LED    ˸
    ini_pwm();
    LED_time = 0;
    //
    UartInit(conf.BaudRate);
    //2401
    if(ini_nRF24L01(&conf))
    {
        //2401ʼʧ
        while(1);
    }else
    {
        //2401ʼ
        LED_time = 20;
    }
    return 0;
}

/***************************
        ״̬
***************************/
void SendStatus(uint8_t sta)
{
    uint8_t buf[] = {0xaa,0x55,0x02,0x00,0x00,0x55,0xaa};
    //               ʼ      У 
    buf[3] = sta;
    buf[4] = BCC((buf + 2), 2);
    UartSend(buf,7);
}

/***************************
        ϴ
***************************/
void UpLoadData()
{
    uint8_t buf[39] = {0xaa,0x55,  34,0x02};
    //               ʼ      У 
    buf[37] = 0x55;
    buf[38] = 0xaa;
    memcpy(&(buf[4]),nRF_RX_BUF,32);
    memset(nRF_RX_BUF,0,32);
    buf[36] = BCC((buf + 2), 34);
    UartSend(buf,39);
}

//鴮
uint8_t CheckRXBuf()
{
    int cntsta;
    if (RecvCnt < 5)
    {
        //7
        return 0xff;  //Ĳȫ
    }
    for (cntsta = 0; cntsta < RecvCnt; cntsta++)
    {
        if (RecvBuf[cntsta] == 0xaa)
        {
            if (RecvBuf[cntsta + 1] == 0x55)
            {
                //AA55ʼ
                if ((cntsta + 4 + RecvBuf[cntsta + 2]) <= RecvCnt)
                {
                    if (RecvBuf[(cntsta + 3 + RecvBuf[cntsta + 2])] == 0x55)
                    {
                        if (RecvBuf[(cntsta + 4 + RecvBuf[cntsta + 2])] == 0xaa)
                        {
                            //55AA룬УRCC
                            if (RecvBuf[cntsta + RecvBuf[cntsta + 2] + 2] == BCC(&(RecvBuf[cntsta + 2]), RecvBuf[cntsta + 2]))
                            {
                                return cntsta;
                            }
                        }
                    }
                }
                else
                {
                    //Ĳȫ
                    return 0xff;
                }
            }
        }
    }
    return 0xff;  //Ĵ
}

/**************************************
ӱлȡ
: ýṹַ  Чλ
:
0x00:ȫ
0x01:Ĭϲ
0x02:Ĭϵַ
0x04:Ĭ2401
0x08:Ĭ2401ͨ
0xff:ȫȡʧ
***************************************/
uint8_t GetConfig(nRF_ConfigStruct *conf,uint8_t cnt)
{
    uint8_t ret = 0x00;
    if((RecvBuf[cnt] == 19) && (RecvBuf[cnt + 1] == 0x03))
    {
        //Ϊ0x03
        if(RecvBuf[cnt + 2] > 126)
        {
            //ͨ
            ret |= 0x08;
            conf -> nRFRFCH = 0x00;
        }else
        {
            conf -> nRFRFCH = RecvBuf[cnt +2];
        }
        conf -> nRFCONFIG = RecvBuf[cnt + 3];
        conf -> nRFRFSETUP = RecvBuf[cnt + 4];
        conf -> nRFSetupRetr = RecvBuf[cnt + 0x12];
        //
        conf-> BaudRate = RecvBuf[cnt + 0x11];
        if(conf-> BaudRate > 0x07)
        {
            conf-> BaudRate = 0x07;
            ret |= 0x01;
        }
        //TxADDR
        if(RecvBuf[cnt + 5] == 0xff)
        {
            memcpy(conf -> nRFTxADDR, &(RecvBuf[cnt + 6]), 5);
        }
        else
        {
            memset(conf -> nRFTxADDR, 0xff, 5);
            ret |= 0x02;
        }
        //RxADDR
        if(RecvBuf[cnt + 0x0b] == 0xff)
        {
            memcpy(conf -> nRFRxADDR, &(RecvBuf[cnt + 0x0c]), 5);
        }
        else
        {
            memset(conf -> nRFRxADDR, 0xff, 5);
            ret |= 0x02;
        }
    }
    else
    {
        return 0xff;
    }
    return ret;
}

/***************************************
Աȵǰ
0xff:òͬ
0:   ͬ
***************************************/
uint8_t Config_Equa(uint8_t *conf1, uint8_t *conf2)
{
    uint8_t cnt;
    for(cnt = 0; cnt < 15; cnt++)
    {
        if(*conf1++ != *conf2++)
        return 0xff;
    }    
    return 0;
}

/***************************************

***************************************/
/**************************************
        ݴ
:Чλ
:
00:ݴ     
10:EEPROMʧܣδ֪
11:EEPROMʧܣѹ
20:2401ʧܣδ֪
30:,յλר
40:δ֧
ff:δ֪
**************************************/
uint8_t DataHand(uint8_t cnt)
{
    uint8_t TXBUF[32];
    uint8_t num;
    nRF_ConfigStruct *ConfWrite = (nRF_ConfigStruct *)TXBUF;
    nRF_ConfigStruct *ConfRead  = (nRF_ConfigStruct *)&(TXBUF[16]);
    memset(TXBUF, 0x00, 32);
    //ĬϱУɹ,ֱʼ롢뼰У鱨Ĺ
    cnt += 2;
    switch(RecvBuf[cnt + 1])
    {
        case 0x00:
            //طݣݲ֧
            num = 0x40;
            break;
        case 0x01:
            //ݣλ-->2401
            memset(TXBUF, 0x00, 32);
            memcpy(TXBUF, &(RecvBuf[cnt + 2]), RecvBuf[cnt] - 2);
            nRF_send(TXBUF);
            num = 0;
            break;
        case 0x02:
            //յݣλרָ
            num = 0x30;
            break;
        case 0x03:
            //޸
            GetConfig(ConfWrite,cnt);   //ӱĻȡ
            unini_PWM();
            LED = 0;
            delay_ms(1000);
            EEPROM_ReadConfig((uint8_t *)ConfRead);    //EEPROMȡ
            if(Config_Equa((uint8_t *)ConfWrite, (uint8_t *)ConfRead))
            {
                //ñıд
                EEPROM_WriteConfig((uint8_t *)ConfWrite);
            } 
            soft_reset();
            num = 0;
            break;
        case 0x04:
            //ȡ
            EEPROM_ReadConfig(&(TXBUF[4]));
            TXBUF[0] = 0xaa;
            TXBUF[1] = 0x55;
            TXBUF[2] = 26;
            TXBUF[3] = 0x04;
            //к
            SOC_ID(&(TXBUF[21]));
            for(num = 20;num > 13;num--)
            {
                TXBUF[num] = TXBUF[num - 2];    
            }
            for(num = 12; num > 7; num--)
            {
                TXBUF[num] = TXBUF[num - 1];
            }
            TXBUF[13] = 0xff;
            TXBUF[7] = 0xff;
            TXBUF[28] = BCC(&(TXBUF[2]),27);
            TXBUF[29] = 0x55;
            TXBUF[30] = 0xaa;
            UartSend(TXBUF,31);
            num = 0;
            break;
        case 0x05:
            //ͳɹλרָ
        case 0x06:
            //ͳʱλרָ
        case 0x07:
            //ʧܣλרָ
            num = 0x30;
            break;
        case 0x08:
            //豸 
            unini_PWM();
            LED = 0;
            delay_ms(1000);
            soft_reset();
            num = 0;
            break;    
        case 0x09:
            //豸   
            unini_PWM();
            LED = 0;
            delay_ms(1000);
            RSTConf();
            num = 0;
            break;       
        case 0x0a:
            //
            num = 0xff;
            break;
        default:
            //δ֪
            num = 0x40;
            break;
    }
    RecvCnt = 0;
    return num;
}

//ݸʽ:
//AA 55    RCC 55 AA
//0x00 ط
//0x01 
//0x02 յ
//0x03 ޸
//0x04 ȡ
//0x05 ͳɹ
//0x06 ͳʱ
//0x07 ʧ
//0x08 豸
//0x09 豸
//0x0a 



