#include "eeprom.h"  
#include "delay.h"
#include "reset.h"
#include "command.h"
#include <string.h>
#include "pwm.h"

//#include "uart.h"

/*----------------------------
رIAP
----------------------------*/
void IapIdle()
{
    IAP_CONTR = 0;                  //رIAP
    IAP_CMD = 0;                    //Ĵ
    IAP_TRIG = 0;                   //Ĵ
    IAP_ADDRH = 0x80;               //ַõIAP
    IAP_ADDRL = 0;
}

/*----------------------------
ISP/IAP/EEPROMȡһֽ
----------------------------*/
uint8_t IapReadByte(uint16_t addr)
{
    uint8_t dat;                       //ݻ

    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_READ;             //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    delay_us(1);                    //ȴISP/IAP/EEPROM            2ʱź
    dat = IAP_DATA;                 //ISP/IAP/EEPROM
    IapIdle();                      //رIAP

    return dat;                     //
}

/*----------------------------
дһֽݵISP/IAP/EEPROM
----------------------------*/
void IapProgramByte(uint16_t addr, uint8_t dat)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_PROGRAM;          //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_DATA = dat;                 //дISP/IAP/EEPROM
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    delay_us(60);                   //ȴISP/IAP/EEPROM            55us
    IapIdle();
}

/*----------------------------

----------------------------*/
void IapEraseSector(uint16_t addr)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_ERASE;            //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    delay_ms(22);                   //ȴISP/IAP/EEPROM            21ms
    IapIdle();
}



/*----------------------------
дһҳ
----------------------------*/
uint8_t EEPROM_WriteConfig(uint8_t *buf)
{
    uint8_t cnt;

    IapEraseSector(EEPROM_CONF_ADDR);

    
    for(cnt = 0; cnt < EEPROM_CONF_LEN; cnt++)
    {
        IapProgramByte(EEPROM_CONF_ADDR + cnt, *buf++);
    }

    return 0;
}

/*----------------------------

----------------------------*/
uint8_t RSTConf()
{
    nRF_ConfigStruct conf;
    conf.nRFRFCH = 0x00;
    conf.nRFCONFIG = 0x0f;
    conf.nRFRFSETUP = 0x0f;
    conf.BaudRate = 0x07;
    conf.nRFSetupRetr = 0x1a;
    memset(conf.nRFTxADDR, 0xff,5);
    memset(conf.nRFRxADDR, 0xff,5); 
    EEPROM_WriteConfig((uint8_t *)(&conf));
    return 0;
}

/*----------------------------
ȡҳ
0   ȡ
1   ѻָĬ
0 ȡʧ
----------------------------*/
uint8_t EEPROM_ReadConfig(uint8_t *buf)
{
    uint8_t cnt;
    uint8_t temp;
    temp =  IapReadByte(EEPROM_CONF_ADDR);
    if(temp == 0xff)
    {
        //ñ
        RSTConf();
    }
    for(cnt = 0; cnt < EEPROM_CONF_LEN; cnt++)
    {
        *buf++ = IapReadByte(EEPROM_CONF_ADDR + cnt);
    }
    return 0;
}

/*----------------------------
ҳ
ҳʼλд0
----------------------------*/
//void EEPROM_Clean_Page(uint16_t Config_Addr)
//{
//    IapProgramByte(Config_Addr,0x00);
//}





//void EEPROM_test()
//{
//    uint8_t buf[16];
//    uint8_t cnt1,cnt;
//    uint16_t eeprom_addr;
//    printf("ʼEEPROM\r\n");
//    delay_ms(50);
////    printf("ȡ%dҳ:\r\n");
//    
//    for(cnt1 = 0; cnt1 < 10;cnt1++)
//    {        
//        printf("ȡ%dҳ:\r\n",(int)cnt1);
//        for(cnt = 0; cnt < EEPROM_PAGE; cnt++)
//        {
//            buf[cnt] = IapReadByte(((uint16_t)cnt) + cnt1 * EEPROM_PAGE);
//        }
//    
//        printf(":\r\n");
//        delay_ms(50);
//        for(cnt = 0; cnt < EEPROM_PAGE; cnt++)
//        {
//            printf("0x%x ",(int)buf[cnt]);
//            delay_ms(5);
//        }
//        delay_ms(50);
//    }
//
//    printf("д\r\n");
//    for(cnt = 0; cnt < EEPROM_PAGE; cnt++)
//    {
//        IapProgramByte(((uint16_t)cnt), cnt);    
//    }
//    printf("д\r\n");
//
//    delay_ms(50);
//    
//    for(cnt = 0; cnt < EEPROM_PAGE; cnt++)
//    {
//        buf[cnt] = IapReadByte((uint16_t)cnt);    
//    }
//    printf(":\r\n");
//    delay_ms(50);
//    for(cnt = 0; cnt < EEPROM_PAGE; cnt++)
//    {
//        printf("0x%x ",(int)buf[cnt]);
//        delay_ms(5);
//    }
//
//    printf("ȫ̲:\r\n");
//    for(cnt = 0; cnt < EEPROM_PAGE_NUM; cnt++)
//    {
//        eeprom_addr = cnt * 512;
//        IapEraseSector(eeprom_addr); 
//    }
//
//
//    delay_ms(50);
//    printf(":\r\n");
//
//}



